const reminderFoxBundle = document.getElementById("reminderFox-bundle");  
var reminderFox_snoozed = false;

function loadAlarm() {
		var dateString = window.arguments[0].reminderDate;
		var timeString = window.arguments[0].reminderTime;
		var reminderString = window.arguments[0].reminderText;
		var important = window.arguments[0].importantStatus;
		var snoozeTime = window.arguments[0].snoozeTime;
		
		if ( snoozeTime != null && snoozeTime != "" ) {
			var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
			snoozeTimeList.label = snoozeTime;
		}
		
		// if this is a past reminder, indicate that in the title
		if (  window.arguments[0].alarmMissed == "true" ) {
			document.title = 	document.title + " (" + reminderFox_getBundle().getString( "rf.alarm.missedalarm.title" )  + ")";
		}
		
		document.getElementById("reminderDateText").setAttribute("value", dateString);
		document.getElementById("reminderTimeText").setAttribute("value", timeString);
		document.getElementById("reminderDescriptionText").setAttribute("value", reminderString);				
		if ( important == "true" ) {
				document.getElementById("reminderDescriptionText").setAttribute("style", "color: red;");
		}
		
		playAlarmSound();

}

function playAlarmSound() {
	// play a sound for notification (if the user elects to)
	try {
		var playSound = true;
		try {
			playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
		}
		catch ( e) {
		}
		if ( playSound ) {
			reminderFox_playSound();
	  	} // end if		
	}
	catch ( e ) {
	}
}

function reminderFox_editReminderFromAlarm() {
	var reminderID = window.arguments[0].currentAlarmId;
	if ( reminderID != null ) {
		reminderFox_openAddRemindersDialog2(reminderID);
	}
}

function reminderFox_openAddRemindersDialog2(reminderID) {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 
   if (topWindow) {
    	 topWindow.focus();
		topWindow.	selectReminderById(reminderID	);
		topWindow.editReminder();
   }
   else {
   		var newOptions = { editReminderID: reminderID };
		var dlg = window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
			"addreminder-dialog", "chrome,centerscreen,resizable", "reminders", newOptions);
	}
}

function reminderFox_alarmDone() {
	var alarmId = window.arguments[0].currentAlarmId;
	var reminder =	reminderFox_getRemindersById( alarmId);
	
	// mark reminder's last-acknowleged  (unless snooze was pressed)
	if ( reminder != null && !reminderFox_snoozed ) {
		reminder.alarmLastAcknowledge = new Date().getTime();
		reminderFox_lastModifiedTime = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED) + "";
		reminderFox_writeOutRemindersAndTodos(true);		 
	}
	
	window.close();
//	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
//	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);	
//	var windowEnumerator = reminderFox_getWindowEnumerator();
//
//
//
//	// see if the day has changed since last process
//	if (windowEnumerator.hasMoreElements()) {
//		currentWindow = windowEnumerator.getNext();		
//				currentWindow.setTimeout(tomtest, 4000 );		
//	}	
}

function reminderFox_alarmChooseDone() {
	if ( 	document.getElementById("snoozeButton").getAttribute( "default" ) == true ||
		document.getElementById("snoozeButton").getAttribute( "default" ) == "true"	) {
		reminderFox_snooze();
	}
	else {
		reminderFox_alarmDone();
	}
}

function reminderFox_snoozeTimeChanged() {
	document.getElementById("snoozeButton").setAttribute( "default", true );
	document.getElementById("okButton").setAttribute( "default", false );
}

function reminderFox_snooze() {
		reminderFox_snoozed = true;
		var alarmId = window.arguments[0].currentAlarmId;
		var dateString = window.arguments[0].reminderDate;
		var timeString = window.arguments[0].reminderTime;
		var reminderString = window.arguments[0].reminderText;
		var important = window.arguments[0].importantStatus;
		var missed = window.arguments[0].missedAlarm;
				
		var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
		var snoozeTime = snoozeTimeList.label;
		if ( reminderFox_isInteger( snoozeTime ) ) {
			var currentTime = new Date().getTime();
			var alarmTime = currentTime + (snoozeTime*60000);		
					
			var windowEnumerator =  reminderFox_getWindowEnumerator();
	
			if (windowEnumerator.hasMoreElements()) {
				var oldestWindow = windowEnumerator.getNext();
				// add to list
				oldestWindow.reminderFox_alarmList.length = oldestWindow.reminderFox_alarmList.length + 1;
				oldestWindow.reminderFox_alarmList[oldestWindow.reminderFox_alarmList.length - 1]  = alarmId + ":"  + alarmTime + reminderFox_SNOOZE_CONST;
				oldestWindow.setTimeout('reminderFox_showAlarm("'+dateString+'","'+timeString +'","'+alarmId +'","'+alarmTime+ '","'+reminderString + '","'+important  + '","'+false+ '","'+snoozeTime+'")', snoozeTime*60000);			
			}		
		}
	window.close();
}


